/*
 * Created on 2003. 11. 19.
 */
package addon.client.tcpProxy;

import interfaces.*;

import java.io.IOException;
import java.net.UnknownHostException;

import engin.Platform;
import engin.SocketTransactor;

/**
 * @author hyoki
 * 
 */
public class TcpProxyClient implements Client {
	private String ipAddress = null;
	private int portAddress = 0;
	private boolean start = false;
	private Platform eventHandler = null;


	/**
	 * @return Returns the eventHandler.
	 */
	public Platform getPlatform() {
		return eventHandler;
	}

	/**
	 * @param eventHandler The eventHandler to set.
	 */
	public void setPlatform(Platform eventHandler) {
		this.eventHandler = eventHandler;
	}

	public void setServerAddress(String anIpAddress, int aPortAddress) {
		ipAddress = anIpAddress;
		portAddress = aPortAddress;
	}

	public void start() {
		start = true;
	}

	public void stop() {
		start = false;
	}

	public void init() {
		
	}

	/* (non-Javadoc)
	 * @see engin.Client#getClientTransactor()
	 */
	public SocketTransactor getClientTransactor() {
		try {
			if(start){
				System.out.println("make Client");
				return new SocketTransactor(ipAddress,portAddress);
			}
		} catch (UnknownHostException e) {
			System.err.println("Host Can't reach");
			e.printStackTrace();
		} catch (IOException e){
			System.err.println("Open Socket Fail");
			e.printStackTrace();
		}
		return null;
	}
}
