/*
 * Created on 2003. 12. 13.
 */
package addon.server.tcpProxy;

import interfaces.Server;

import javax.swing.JLabel;
import javax.swing.JTextField;

import addon.AddonPanel;

/**
 * @author hyoki
 * 
 */
public class Addon extends AddonPanel {
	private JLabel label;
	private JTextField text;
	private int portNumber;
	/* (non-Javadoc)
	 * @see addon.AddonPanel#isReady()
	 */
	public boolean isReady() {
		try{
			portNumber = Integer.parseInt(getText().getText());
		} catch (NumberFormatException e) {
			return false;
		}
		if(portNumber < 0 || portNumber > 65535){
			return false;
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see addon.AddonPanel#getHost()
	 */
	public Object getHost() {
		Server server = factory.createServer(Server.PROXY_IF,Server.TCP_IF);
		server.setServerPort(portNumber);
		factory.createPlatform().setServer(server);
		server.init();
		return server;
	}
	public Addon(){
		this.add(getLabel());
		this.add(getText());
	}

	private JTextField getText() {
		if( text == null){
			text = new JTextField("");
			text.setPreferredSize(getLabel().getPreferredSize());
		}
		return text;
	}

	private JLabel getLabel() {
		if( label == null){
			label = new JLabel("Server Port: ");
		}
		return label;
	}

}
