/*
 * Created on 2003. 11. 19.
 */
package addon.server.tcpProxy;

import interfaces.*;

import java.io.IOException;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Iterator;
import java.util.Vector;

import engin.Platform;
import engin.ServerThread;
import engin.SocketTransactor;

/**
 * @author hyoki
 * 
 */
public class TcpProxyServer implements Server {
	private int portNumber = 0;
	private Platform platform = null;
	private ServerSocket server = null;
	private Vector serverSideClients = new Vector();

	/**
	 * @param eventHandler The eventHandler to set.
	 */
	public void setPlatform(Platform eventHandler) {
		this.platform = eventHandler;
	}

	/**
	 * @param clients The clients to set.
	 */
	public void setClients(Vector clients) {
		this.serverSideClients = clients;
	}

	/**
	 * @return Returns the eventHandler.
	 */
	public Platform getPlatform() {
		return platform;
	}

	/**
	 * 
	 */
	public TcpProxyServer() {
		super();
	}

	/* (non-Javadoc)
	 * @see engin.Server#setServerPort(int)
	 */
	public void setServerPort(int aPortNumber) {
		portNumber = aPortNumber;
	}

	/* (non-Javadoc)
	 * @see engin.Host#init(engin.MessageFactory, java.util.Observable)
	 */
	public void init() {
		try {
			if((server == null) || (portNumber != server.getLocalPort())){
				this.server = new ServerSocket(portNumber);
				System.out.println("server Start");
			}
		} catch (BindException e){
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/* (non-Javadoc)
	 * @see engin.Host#start()
	 */

	/**
	 * @param eachServerSocket
	 * @return
	 */
	private SocketTransactor getServerTransactor(Socket eachServerSocket) {
		return new SocketTransactor(eachServerSocket);
	}

	private void closeAllClients(Iterator it) throws IOException {
		while (it.hasNext()) {
			Socket element = (Socket) it.next();
			element.close();
		}
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Thread#interrupt()
	 */
	public void stop() {		
		Iterator it = serverSideClients.iterator();
		try {
				closeAllClients(it);
			server.close();
			server = null;
			System.out.println("Server stop");
		} catch (NullPointerException e) {
		} catch (IOException e) {
			System.err.println("close sockets fail");
			e.printStackTrace();
		}
	}
	int count = 0;
	/* (non-Javadoc)
	 * @see interfaces.Host#start()
	 */
	public void start() {

		if((server == null)){
			try {
				this.server = new ServerSocket(portNumber);
			} catch (IOException e) {
				System.err.println("Server Open Fail");
			}
		}
		Thread thread = new Thread(){
			public void run(){
				while(true){
				try{
				Socket eachServerSocket = server.accept();
				System.out.println("accept: "+count++);
				SocketTransactor serverTransactor = getServerTransactor(eachServerSocket);				
				SocketTransactor clientTransactor = getPlatform().getClient().getClientTransactor();
				Thread thread = new ServerThread(getPlatform(), serverTransactor, clientTransactor);
				thread.start();
				serverSideClients.addElement(eachServerSocket);
				} catch (IOException e) {
					e.printStackTrace();
				}
				}
			}
		};	
		thread.setDaemon(true);
		thread.start();
	}
}
