/*
 * Created on 2003. 11. 18.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package engin;

import interfaces.*;

import java.io.File;

import addon.client.tcpProxy.*;
import addon.server.tcpProxy.*;

/**
 * @author hyoki
 * 
 */ 
public class TextFactory implements PlatformFactory {
	Platform eh = new Platform();
	MessageFactory mf =  new MessageFactory();
	/* (non-Javadoc)
	 * @see interfaces.PlatformFactory#createPlatform()
	 */
	public Platform createPlatform() {
		return eh;
	}

	/* (non-Javadoc)
	 * @see engin.PlatformFactory#createServer(int, int)
	 */
	public Server createServer(int hostType, int networkServiceType) {
		Server server = null;		
		if(isProxy(hostType) && isTCP(networkServiceType)){
			server = new TcpProxyServer();
		}
		return server;
	}

	private boolean isTCP(int networkServiceType) {
		return networkServiceType == Host.TCP_IF;
	}

	private boolean isProxy(int hostType) {
		return hostType == Host.PROXY_IF;
	}

	/* (non-Javadoc)
	 * @see engin.PlatformFactory#createClient(int, int)
	 */
	public Client createClient(int hostType, int networkServiceType) {
		Client client = null;
		if(isProxy(hostType) && isTCP(networkServiceType)){
			client = new TcpProxyClient();
		}
		return client;
	}

	/* (non-Javadoc)
	 * @see engin.PlatformFactory#createDataManager(int)
	 */
	public DataManager createDataManager(int aDataManagerType) {
		DataManager dm = null;
		if(aDataManagerType == DataManager.TEXT_IF){
//			dm = new TextDataManager();
		}
		return dm;
	}

	/* (non-Javadoc)
	 * @see engin.PlatformFactory#cratePlugin(java.lang.String)
	 */
	public Plugin cratePlugin(String pluginName) {
		Plugin plugin = null;
		try {
			plugin = (Plugin)loadClass(pluginName).newInstance();
		} catch (InstantiationException e) {
			System.err.println("Class instantiation fail");
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			System.err.println("Illegal Accsee");
			e.printStackTrace();
		}
		File[] files = plugin.getRequiredFiles();
		if(filesExists(files)){
			return plugin;
		}else{
			throw new UnsupportedOperationException();
		}
	}

	

	/**
	 * @param files
	 * @return
	 */
	private boolean filesExists(File[] files) {
		if(files == null){
			return true;
		}
		for (int i = 0; i < files.length; i++) {
			if(!files[i].exists()){
				return false;
			}
		}
		return true;
	}

	/**
	 * @param pluginName
	 * @return Class
	 */
	private Class loadClass(String pluginName){
		try {
			return ClassLoader.getSystemClassLoader().loadClass(pluginName);
		} catch (ClassNotFoundException e) {
			System.err.println("Class is not Found "+pluginName);
			e.printStackTrace();
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see engin.PlatformFactory#createMessageFactory(engin.EventHandler)
	 */
	public MessageFactory createMessageFactory() {
//		mf.setEventHandler();
		return mf;
	}
}
