/*
 * Created on 2003. 12. 9.
 */
package gui;

import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

/**
 * @author hyoki
 * 
 */
public class AddonFactory {
	Properties properties = new Properties();
	AddonFactory(){
		try {
			loadProperties();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void loadProperties() throws IOException, FileNotFoundException {
		properties.load(new FileInputStream(new File("properties.cfg")));
	}
	/**
	 * @return
	 */
	public TableModel getModel(String type) {
		String listType =(String)properties.get(type.toLowerCase());
		DefaultTableModel model = new DefaultTableModel(new String[]{"Add On","Class"},0){
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		File file = new File(listType);
		if(!file.exists()){return model;}
		File[] files = file.listFiles();
		for (int i = 0; i < files.length; i++) {
			if(files[i].isDirectory()){
				File[] addonPanel = files[i].listFiles(new FileFilter(){
					public boolean accept(File pathname) {
						if(pathname.getName().equals(properties.get("addon"))){
							return true;
						}
						return false;
					}});			
				if(addonPanel.length > 0){
					model.addRow(new Object[]{files[i].getName(),loadClassFromFile(files[i],addonPanel[0])});
				}
				
			}
		}		
		return model;
	}
	/**
	 * @param selectedClassFile
	 * @return
	 */
	private static Class loadClassFromFile(File directory,File selectedClassFile) {
		ClassLoader loader = null;
		try {
			loader = new URLClassLoader(new URL[]{directory.toURL()});
		} catch (MalformedURLException e1) {
			// TODO Auto-generated catch block			
			e1.printStackTrace();
		}
		String className = new StringTokenizer(selectedClassFile.getName(),".").nextToken();
		Class clazz = null;
		try {
			try {
				clazz = loader.loadClass(className);
			} catch (NoClassDefFoundError e) {
				clazz = loader.loadClass(findRightClassName(e));
			}
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return clazz;
	}
	private static String findRightClassName(NoClassDefFoundError e) {
		String rightClassName = null;
		StringTokenizer token = new StringTokenizer(e.getMessage(),":");
		while (token.hasMoreTokens()) {
			rightClassName = token.nextToken().trim();
		}
		rightClassName = rightClassName.substring(0,rightClassName.length()-1);
		return rightClassName;
	}
}
