/*
 * Created on 2003. 12. 9.
 */
package gui;

import interfaces.PlatformFactory;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.TableModel;

import addon.AddonPanel;

/**
 * @author hyoki
 * 
 */
public class NamedTabbedJPanel extends JPanel {
	String name = null;
	private JPanel titleLabelPanel;
	private JTabbedPane tabbedPane;
	private OneTableTwoButtonsPanel addOnsPanel;
	private String addButtonName = "Add";
	private String refreshButtonName = "Refresh";
	private PlatformFactory factory;
	
	private ActionListener buttonsListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			String  buttonName = ((JButton)e.getSource()).getText();
			if(buttonName.equals(addButtonName)){			
				getAddOnsPanel().selectedRowAddTabbedPanel(getTabbedPane(),factory);
				update();
			}else if(buttonName.equals(refreshButtonName)){
				getStateChangeListener().stateChanged(new ChangeEvent(buttonName));
			}else{}
		}};
	/**
	 * @param string
	 */
	public NamedTabbedJPanel(String type, PlatformFactory factory) {
		super();
		name = type+" Type";
		this.factory = factory;
		initComponent();
		update();
	}

	private void update() {}
	/**
	 * 
	 */
	private void initComponent() {
		setLayout(new BorderLayout());
		add(getTitleLabelPanel(),BorderLayout.NORTH);
		add(getTabbedPane(), BorderLayout.CENTER);		
	}
	private JTabbedPane getTabbedPane() {
		if(tabbedPane == null){
			tabbedPane = new JTabbedPane();			
			tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
			tabbedPane.setTabPlacement(JTabbedPane.TOP);
			tabbedPane.setUI(new TabbedPaneCloseButtonUI());
			tabbedPane.addTab("Class List",getAddOnsPanel());
		}
		return tabbedPane;
	}
	private OneTableTwoButtonsPanel getAddOnsPanel() {
		if(addOnsPanel == null){
			addOnsPanel = new OneTableTwoButtonsPanel(addButtonName,refreshButtonName);
			addOnsPanel.setActionListener(buttonsListener);			
		}
		return addOnsPanel;
	}	

	private JPanel getTitleLabelPanel() {
		if(titleLabelPanel == null){
			titleLabelPanel = new JPanel(new BorderLayout());
			titleLabelPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
			titleLabelPanel.add(new JLabel(name),BorderLayout.CENTER);
		}
		return titleLabelPanel;
	}
	public AddonPanel getSelectedPanel(){
		try {
			return (AddonPanel)getTabbedPane().getSelectedComponent();			
		} catch (ClassCastException e) {
			return null;
		}
	}
	/**
	 * @param model
	 */
	public void setTableModel(TableModel model) {
		getAddOnsPanel().setModel(model);
	}
	private ChangeListener listener = null;
	/**
	 * @param listener
	 */
	public void setStateChangeListener(ChangeListener listener) {
		this.listener = listener;
	}
	public ChangeListener getStateChangeListener(){
		return listener;
	}
}
