/*
 * Created on 2003. 12. 9.
 */
package gui;

import interfaces.PlatformFactory;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableModel;

import addon.AddonPanel;

/**
 * @author hyoki
 * 
 */
public class OneTableTwoButtonsPanel extends JPanel {

	private JPanel twoButtons;
	private JButton firstButton;
	private JTable table;
	private JButton secondButton;
	private String firstButtonName;
	private String secondButtonName;
	
	public OneTableTwoButtonsPanel(String firstName, String secondName){
		super();
		firstButtonName = firstName;
		secondButtonName = secondName;
		initComponent();
		update();
	}
	/**
	 * 
	 */
	private void update() {		
		updateFirstButton();
		updateSecondButton();
		updateTable();
	}
	/**
	 * 
	 */
	public void updateTable() {}
	/**
	 * 
	 */
	public void updateSecondButton() {}
	/**
	 * 
	 */
	public void updateFirstButton() {
		if(getTable().getModel().getRowCount()>0){
			getFirstButton().setEnabled(true);
		}else{
			getFirstButton().setEnabled(false);
		}		
	}
	/**
	 * 
	 */
	private void initComponent() {
		setLayout(new BorderLayout());
		add(getControlButtons(),BorderLayout.EAST);
		JScrollPane scroll = new JScrollPane(getTable(),JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		add(scroll,BorderLayout.CENTER);
	}
	/**
	 * @return
	 */
	private JPanel getControlButtons() {
		if(twoButtons == null){
		twoButtons = new JPanel();
		twoButtons.setLayout(new GridLayout(2,1));
		twoButtons.add(getFirstButton());
		twoButtons.add(getSecondButton());
		}
		return twoButtons;
	}
	/**
	 * @return
	 */
	private JButton getSecondButton() {
		if(secondButton == null){
			secondButton = new JButton(secondButtonName);
		}
		return secondButton;
	}
	/**
	 * @return
	 */
	private JButton getFirstButton() {
		if (firstButton == null){
		firstButton = new JButton(firstButtonName);
		}
		return firstButton;
	}
	public void setActionListener(ActionListener listener){
		getFirstButton().addActionListener(listener);
		getSecondButton().addActionListener(listener);		
	}
	/**
	 * @return
	 */
	private JTable getTable() {
		if(table == null){
			table = new JTable();
			table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return table;
	}
	/**
	 * @param model
	 */
	public void setModel(TableModel model) {
		getTable().setModel(model);
		update();
	}
	/**
	 * @param pane
	 */
	public void selectedRowAddTabbedPanel(JTabbedPane pane, PlatformFactory factory) {		
		try {
			String name = (String) this.getTable().getModel().getValueAt(this.getTable().getSelectedRow(),0);
			AddonPanel instance = (AddonPanel)((Class)this.getTable().getModel().getValueAt(this.getTable().getSelectedRow(),1)).newInstance();
			instance.setPlatform(factory);
			pane.addTab(name,instance);
		}catch (Exception e) {
			// TODO: handle exception
		}
		
	}
}
