/*
 * Created on 2003. 12. 1.
 */
package gui;

import interfaces.Client;
import interfaces.Host;
import interfaces.Plugin;
import interfaces.Server;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

/**
 * @author hyoki
 * 
 */
public class RunningHostesPanel extends JPanel {
	private DefaultTableModel defaultTableModel = new DefaultTableModel(new String[]{"Server Side","Server Fields","Plugin","Plugin Fields","Client Side","Client Felds","Run"},0){
		public boolean isCellEditable(int row, int col) {
			if( col < getColumnCount()-1){
				return false;
 			}else{
				return true;
			}
		}
	}; 
	private JTable runningTable = null;
	private boolean updating = false;
	public RunningHostesPanel(){
		super();
		initComponent();
		update();
	}
	/**
	 * 
	 */
	public void update() {
		beginUpdating();
		updateUI();
		endUpdating();
	}


	/**
	 * @return
	 */
	private boolean isUpdateing() {
		return updating;
	}
	/**
	 * 
	 */
	private void endUpdating() {
		updating = false;		
	}

	/**
	 * 
	 */
	private void beginUpdating() {
		updating = true;
	}

	/**
	 * 
	 */
	private void initComponent() {
		setLayout(new BorderLayout());
		add(new JScrollPane(getRunningTable(),JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED),BorderLayout.CENTER);
	}
	/**
	 * @return
	 */
	private JTable getRunningTable() {
		if(runningTable == null){
			runningTable = new JTable(defaultTableModel);
			JComboBox comboBox = new JComboBox();
			comboBox.addItem("Run");
			comboBox.addItem("Stop");
			comboBox.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					if(getRunningTable().getSelectedRow()>-1){
						updateRunningState((JComboBox)e.getSource());
					}
				}});
			runningTable.getColumnModel().getColumn(defaultTableModel.getColumnCount()-1).setCellEditor(new DefaultCellEditor(comboBox));
			runningTable.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return runningTable;
	}
	private void runHostes() {		
		int selection = getRunningTable().getSelectedRow();
		getHostAt(selection,1).start();
		getHostAt(selection,5).start();
	}
	private Host getHostAt(int selection, int type) throws ArrayIndexOutOfBoundsException{
		return (Host) defaultTableModel.getValueAt(selection,type);
	}

	private void stopHostes() {
		int selection = getRunningTable().getSelectedRow();
		getHostAt(selection,1).stop();
		getHostAt(selection,5).stop();
	}

	private void updateRunningState(JComboBox comboBox) {
		int itemIndex = comboBox.getSelectedIndex();
		if (itemIndex == 0) {
			runHostes();
		} else if(itemIndex == 1){
			stopHostes();
		}else{
			throw new UnsupportedOperationException();
		}
	}


	/**
	 * 
	 */
	public void clearSelection() {
		runningTable.clearSelection();
		update();
	}



	/**
	 * @param object
	 */
	public void addHostes(Hostes hostes) throws NullPointerException {
		if(isUpdateing()) return;
		Server	server = hostes.getServer();
		Plugin	plugin = hostes.getPlugin();
		Client	client = hostes.getClient();
		Vector row = new Vector();
		row.add(server.getClass().getName());
		row.add(server);
		row.add(plugin.getClass().getName());
		row.add(plugin);
		row.add(client.getClass().getName());
		row.add(client);		
		defaultTableModel.addRow(row);
		client.start();
		server.start();
		defaultTableModel.setValueAt("Run",defaultTableModel.getRowCount()-1,defaultTableModel.getColumnCount()-1);
		update();		
	}

	/**
	 * 
	 */
	public void removeHostes() {
		if(isUpdateing()) return;
		if(getRunningTable().getSelectedRowCount() != 0){
			defaultTableModel.removeRow(getRunningTable().getSelectedRow());
		}
		update();
	}

	/**
	 * @return
	 */
	public boolean isSelected() {
		if(getRunningTable().getSelectedRowCount() == 0){
			return false;
		}else{
			return true;
		}
	}

	/**
	 * @return
	 */
	public boolean isEmpty() {
		if(getRunningTable().getModel().getRowCount() == 0){
			return true;
		}else{
			return false;
		}
	}
}
