/*
 * Created on 2003. 11. 30.
 */
package gui;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 * @author hyoki
 * 
 */
public class RunningPanel extends JPanel {
	private JButton startButton = null;
	private JButton removeButton = null;
	private RunningHostesPanel runningHostesPanel = null;
	private JPanel startPanel = null;
	private boolean updating;
	
	private ActionListener buttonsActionListener = new ActionListener(){

		public void actionPerformed(ActionEvent e) {
			JButton button = (JButton)e.getSource();
			if(button.getText().equals("Remove")){
				getRunningHostesPanel().removeHostes();
			}else if(button.getText().equals("Start")){
				if(getRunningHostesPanel().isSelected()){
					getRunningHostesPanel().clearSelection();
					return;
				}
				getStartActionListener().actionPerformed(e);
			}else{
				throw new IllegalArgumentException();
			}
			update();
		}};
	private ActionListener startActionListener;
	/**
	 * @return Returns the runPanel.
	 */
	private JPanel getStartPanel() {
		if (startPanel == null) {
			startPanel = new JPanel(new GridLayout(2,1));
			startPanel.add(getStartButton());
			startPanel.add(getRemoveButton());
		}
		return startPanel;
	}


	/**
	 * 
	 */
	protected ActionListener getStartActionListener() {
		return startActionListener;
	
	}
	


	/**
	 * @return
	 */
	protected boolean isStartReady() {
		return ready;
//		return ((BackGroundPanel)getParent()).isStartReady();
		// TOTHINK change Event Driven
	}
	private boolean ready = false;
	/**
	 * @return Returns the runningHostesPanel.
	 */
	private RunningHostesPanel getRunningHostesPanel() {
		if(runningHostesPanel == null){
			runningHostesPanel = new RunningHostesPanel();
		}
		return runningHostesPanel;
	}

	/**
	 * @return Returns the runButton.
	 */
	public JButton getStartButton() {
		if(startButton == null){
			startButton = new JButton("Start");
			startButton.addActionListener(buttonsActionListener);
		}
		return startButton;
	}

	/**
	 * @return
	 */
	private JButton getRemoveButton() {
		if(removeButton == null){
			removeButton = new JButton("Remove");
			removeButton.addActionListener(buttonsActionListener);
		}
		return removeButton;
	}	
	/**
	 * 
	 */
	protected void update() {
		beginUpdating();
		updateItemsTable();
		updateRemoveButton();
		endUpdating();
	}

	/**
	 * 
	 */
	private void endUpdating() {
		updating = false;
	}

	/**
	 * 
	 */
	private void beginUpdating() {
		updating = true;
	}
	private boolean isUpdating(){
		return updating;		
	}
	/**
	 * 
	 */
	private void updateRemoveButton() {
		getRemoveButton().setEnabled(!getRunningHostesPanel().isEmpty());
	}
	/**
	 * 
	 */
	private void updateItemsTable() {
		getRunningHostesPanel().update();
	}
	public RunningPanel(){
		setLayout(new BorderLayout());
		setBorder(BorderFactory.createEmptyBorder(5, 0, 0, 0));
		initComponent();
		update();
	}
	private void initComponent() {
		add(getRunningHostesPanel(), BorderLayout.CENTER);
		add(getStartPanel(), BorderLayout.EAST);
	}
	/**
	 * @param objects
	 */
	public void addHostes(Hostes hostes) {
		try {
			getRunningHostesPanel().addHostes(hostes);
		} catch (NullPointerException e) {
		}
	}

	/**
	 * @param startActionListener The startActionListener to set.
	 */
	public void setStartActionListener(ActionListener startActionListener) {
		this.startActionListener = startActionListener;
	}
}
