package gui;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
public class TabbedPaneCloseButtonUI extends BasicTabbedPaneUI {
	public TabbedPaneCloseButtonUI() {
		super();
	}
	protected void paintTab(
		Graphics g,
		int tabPlacement,
		Rectangle[] rects,
		int tabIndex,
		Rectangle iconRect,
		Rectangle textRect) {
		super.paintTab(g, tabPlacement, rects, tabIndex, iconRect, textRect);
		Rectangle rect = rects[tabIndex];
		g.setColor(Color.black);
		g.drawRect(rect.x + rect.width - 19, rect.y + 4, 13, 12);
		g.drawLine(
			rect.x + rect.width - 16,
			rect.y + 7,
			rect.x + rect.width - 10,
			rect.y + 13);
		g.drawLine(
			rect.x + rect.width - 10,
			rect.y + 7,
			rect.x + rect.width - 16,
			rect.y + 13);
		g.drawLine(
			rect.x + rect.width - 15,
			rect.y + 7,
			rect.x + rect.width - 9,
			rect.y + 13);
		g.drawLine(
			rect.x + rect.width - 9,
			rect.y + 7,
			rect.x + rect.width - 15,
			rect.y + 13);
	}
	protected int calculateTabWidth(
		int tabPlacement,
		int tabIndex,
		FontMetrics metrics) {
		return super.calculateTabWidth(tabPlacement, tabIndex, metrics) + 24;
	}
	protected MouseListener createMouseListener() {
		return new MyMouseHandler();
	}
	class MyMouseHandler extends MouseHandler {
		public MyMouseHandler() {
			super();
		}
		public void mouseReleased(MouseEvent e) {
			int x = e.getX();
			int y = e.getY();
			int tabIndex = -1;
			int tabCount = tabPane.getTabCount();
			for (int i = 0; i < tabCount; i++) {
				if (rects[i].contains(x, y)) {
					tabIndex = i;
					break;
				}
			}
			if (tabIndex >= 0 && !e.isPopupTrigger()) {
				Rectangle tabRect = rects[tabIndex];
				y = y - tabRect.y;
				if ((x >= tabRect.x + tabRect.width - 18)
					&& (x <= tabRect.x + tabRect.width - 8)
					&& (y >= 5)
					&& (y <= 15)) {
					if(tabIndex != 0){
						tabPane.remove(tabIndex);
					}
				}
			}
		}
	}
}